/* static  char sccsid[] = "@(#)dai.h 8.14 96/03/27 Copyr 1985-1993 Sun Micro"; */
/*
      Copyright 1993 Sun Microsystems, Inc. All Rights Reserved.
            Printed in the United States of America.
2550 Garcia Avenue, Mountain View, California, 94043-1100 U.S.A.

This product and related documentation is protected by 
copyright and distributed under licenses restricting its use, copying, 
distribution and decompilation.  No part of this product or related 
documentation may be reproduced in any form by any means without prior 
written authorization of Sun and its licensors, if any.

Portions of this product may be derived from the UNIX(R) and Berkeley 4.3 BSD 
systems, licensed from UNIX Systems Laboratories, Inc. and the University of 
California, respectively.  Third party font software in this product is
protected by copyright and licensed from Sun's Font Suppliers. 
  
RESTRICTED RIGHTS LEGEND:  Use, duplication, or disclosure by the government 
is subject to restrictions as set forth in subparagraph (c)(1)(ii) of the
Rights in Technical Data and Computer Software clause at DFARS 252.227-7013
and FAR 52.227-19.
 
Sun, Sun Microsystems, the Sun Logo, Solaris, SunOS, ONC, NFS, OpenWindows,
DeskSet, AnswerBook, SunLink, SunView, SunDiag, NeWS, OpenBoot, 
OpenFonts, SunInstall, SunNet, ToolTalk, X11/NeWS and XView are trademarks or 
registered trademarks of Sun Microsystems, Inc.  UNIX and OPEN LOOK are 
registered trademarks of UNIX System Laboratories, Inc. PostScript is a 
registered trademark of Adobe Systems, Inc.  All other product names 
mentioned herein are the trademarks of their respective owners.
 
All SPARC trademarks, including the SCD Compliant Logo, are trademarks or 
registered trademarks of SPARC International, Inc. SPARCstation, SPARCserver, 
SPARCengine, SPARCworks and SPARCompiler are licensed exclusively to Sun 
Microsystems, Inc.  Products bearing SPARC trademarks are based upon an 
architecture developed by Sun Microsystems, Inc. 

The OPEN LOOK(R) and Sun(TM) Graphical User Interfaces were developed by 
Sun Microsystems, Inc. for its users and licensees.  Sun acknowledges the 
pioneering efforts of Xerox in researching and developing the concept of 
visual or graphical user interfaces for the computer industry.  Sun holds 
a non-exclusive license from Xerox to the Xerox Graphical User Interface, 
which license also covers Sun's licensees who implement OPEN LOOK GUIs and 
otherwise comply with Sun's written license agreements.

The X Window System is a product of the Massachusetts Institute of 
Technology.

This product incorporates technology used under license from Fulcrum 
Technology.
*/
 
/* dai.h */

/* Values for ds_state */

enum ds_state
{
	ds_inact,		/* Host communication not established */
					/*    for SNA, ACTLU pending */
	ds_appl,		/* For SNA, connected to PLU */
					/* For BSC, this is host polling state */
	ds_sscp,		/* (SNA only) connected to SSCP */
	ds_unown,		/* (SNA only) not connected to SSCP or PLU */
	ds_unavail		/* Device is unavailable for host read/write */
					/*   Corresponds to 3278 Security Key Lock */
};

/* Values for ds_type */

enum ds_type
{
	/* These old values included for backwards compatibility */

	ds_bscptr,		/* Device is a BSC printer */
	ds_bscdsp,		/* Device is a BSC display, model 2 */
	ds_snalu1,		/* Device is an SNA SCS printer (LU type 1) */
	ds_snalu2,		/* Device is an SNA display (LU type 2), model 2 */
	ds_snalu3,		/* Device is an SNA DSC printer (LU type 3) */
					/*  default for unbound SNA printer */
	ds_snalu2m3,	/* Device is an SNA display (LU type 2), model 3 */
	ds_snalu2m4,	/* Device is an SNA display (LU type 2), model 4 */
	ds_snalu2m5,	/* Device is an SNA display (LU type 2), model 5 */

	/* This new value is the only one needed for 8.0 DAI */
	ds_snarje,		/* Device is a SNA RJE terminal */

	ds_bscdspm3,	/* Device is a BSC display, model 3 */
	ds_bscdspm4,	/* Device is a BSC display, model 4 */
	ds_bscdspm5,	/* Device is a BSC display, model 5 */

	/* These 3 new values are the only ones needed for 6.0 DAI */

	ds_ptr_scs,		/* Device is a SCS printer */
	ds_ptr_dsc,		/* Device is a DSC printer */
	ds_display		/* Device is a display */
};

/* Values for ds_termno */

#define DS_UNKNOWN -1		/* terminal number is not known */

typedef struct
{
	enum ds_state ds_state;	/* current state of the device (see above) */
	enum ds_type ds_type;	/* type of the device (see above) */
	u_char ds_size[5];		/* bytes 20-24 of SNA bind; unused in BSC */
	int ds_kybdlk;			/* Zero is unlocked, non-zero locked */
	int ds_err400;			/* Series 400 program check error */
	int ds_err500;			/* Series 500 program check error */
	int ds_termno;			/* terminal number (DS_UNKNOWN if not known) */
} DS_STATUS;

#define	DS_STATUS_NEW_MAGIC	0x0badbeef

typedef struct
{
	enum ds_state ds_state;	/* current state of the device (see above) */
	enum ds_type ds_type;	/* type of the device (see above) */
	u_char ds_size[5];		/* bytes 20-24 of SNA bind; unused in BSC */
	int ds_kybdlk;			/* Zero is unlocked, non-zero locked */
	int ds_err400;			/* Series 400 program check error */
	int ds_err500;			/* Series 500 program check error */
	int ds_termno;			/* terminal number (DS_UNKNOWN if not known) */
	int ds_magic;			/* MUST == DS_STATUS_NEW_MAGIC */
	int ds_rusize;			/* 'maxlsegmt' from gateway */
	int ds_lucnt;			/* max lu count from gateway */
} DS_STATUS_NEW;

typedef struct { int seal; } DS_DAI;

/* Values for props in ds_open procedure */

	/* These old values included for backwards compatibility */

#define DS_PRINTER	0x01	/* Device is a printer */
#define DS_REJSNA	0x02	/* Device does NOT support SNA protocol */
#define DS_REJBSC	0x04	/* Device does NOT support BSC protocol */

#define DS_SNAPRT	0x1000	/* Device is a SNA printer */
#define DS_SCSPRT	0x2000	/* Device is a SCS printer */

#define DS_MODEL3	0x20	/* Device is a model 3 */
#define DS_MODEL4	0x40	/* Device is a model 4 */
#define DS_MODEL5	0x80	/* Device is a model 5 */

	/* These 2 old values, 4 new values are the only ones needed for 6.0 DAI */

#define DS_REJLU1	0x08	/* Device does NOT support LU type 1 */
#define DS_REJLU3	0x10	/* Device does NOT support LU type 3 */

#define DS_RM_SNA	0x100	/* Remote SNA protocol supported */
#define DS_RM_BSC	0x200	/* (Remote) BSC protocol supported */
#define DS_DA_SNA	0x400	/* Direct-attach SNA protocol supported */
#define DS_DA_CHL	0x800	/* Direct-attach channel protocol supported */

	/* one more value for 7.0 DAI */

#define DS_SNAPLUFMH	0x4000	/* Device accepts SNA LU-LU session FMH data */

	/* one more value for 8.0 DAI */

#define DS_SNARJE	0x8000	/* Device is a SNA RJE terminal */

	/* used in power on mesage */

#define SNAPLUFMH	0x80	/* Device accepts SNA FMH data */


/* Flags for ds_read and ds_write */

#define DS_MORE		0x01	/* More data to come */
#define DS_PLU		0x02	/* (SNA read/write only) Data is for/from PLU */
#define DS_NEWCMD	0x04	/* (BSC read only) Start of new, chained command */
#define DS_TSTREQ	0x08	/* (BSC ds_write only) TEST_REQ is being sent */
#define DS_CPYBUF	0x10	/* (BSC read/write only) Copy command buffer data */
#define DS_CPYMAP	0x20	/* (BSC read/write only) Copy command bitmap data */
#define DS_RDBITS	0xC0	/* (ds_write) Mask for READ bits */

#define DS_NON_RD	0x00	/* (ds_write) No READ modifier bits */
#define DS_RD_MOD	0x40	/* (ds_write) READ MODIFIED command */
#define DS_RM_ALL	0x80	/* (ds_write) READ MODIFIED ALL cmd */
#define DS_RD_BUF	0xC0	/* (ds_write) READ BUFFER command */
#define DS_NEWDATA	0x100	/* (ds_read) newdata has been read */
				/* added for 8.0		    */


/* Value for control in ds_control procedure */

enum ds_control
{
	ds_attn,		/* (SNA only) The attn key has been entered */
	ds_key,			/* A keystroke has been entered */
					/*  "pre-write" to block BIDs */
	ds_unavl,		/* Device has become unavailable */
	ds_avl,			/* Device has become available */
	ds_nocopy,		/* (BSC only) Copy command can't be executed; device is */
					/* locked: protected/alphameric attribute byte in addr 0 */
	ds_rlg,			/* RU length error        sense bytes 1002 */
	ds_prm,			/* Parameter error        sense bytes 1005 */
	ds_fns,			/* Function Not Supported sense bytes 1003 */
	ds_rts,			/* SNA RJE 'request-to-send' */
	ds_nby			/* not busy (bsc only (apparently)) */
};

/* AID values */

#define ENTER	0x7d
#define PF1		0xf1
#define PF2		0xf2
#define PF3		0xf3
#define PF4		0xf4
#define PF5		0xf5
#define PF6		0xf6
#define PF7		0xf7
#define PF8		0xf8
#define PF9		0xf9
#define PF10	0x7a
#define PF11	0x7b
#define PF12	0x7c
#define PF13	0xc1
#define PF14	0xc2
#define PF15	0xc3
#define PF16	0xc4
#define PF17	0xc5
#define PF18	0xc6
#define PF19	0xc7
#define PF20	0xc8
#define PF21	0xc9
#define PF22	0x4a
#define PF23	0x4b
#define PF24	0x4c
#define CURSR_SEL	0x7e
#define PA1		0x6c
#define PA2		0x6e
#define PA3		0x6b
#define CLEAR	0x6d
#define TEST_REQ	0xf0

#define ASCII_ENTER	0x27
#define ASCII_PF1	0x31
#define ASCII_PF2	0x32
#define ASCII_PF3	0x33
#define ASCII_PF4	0x34
#define ASCII_PF5	0x35
#define ASCII_PF6	0x36
#define ASCII_PF7	0x37
#define ASCII_PF8	0x38
#define ASCII_PF9	0x39
#define ASCII_PF10	0x3a
#define ASCII_PF11	0x23
#define ASCII_PF12	0x40
#define ASCII_PF13	0x41
#define ASCII_PF14	0x42
#define ASCII_PF15	0x43
#define ASCII_PF16	0x44
#define ASCII_PF17	0x45
#define ASCII_PF18	0x46
#define ASCII_PF19	0x47
#define ASCII_PF20	0x48
#define ASCII_PF21	0x49
#define ASCII_PF22	0x5b
#define ASCII_PF23	0x2e
#define ASCII_PF24	0x3c
#define ASCII_CURSR_SEL	0x3d
#define ASCII_PA1	0x25
#define ASCII_PA2	0x3e
#define ASCII_PA3	0x2c
#define ASCII_CLEAR	0x5f
#define ASCII_TEST_REQ	0x30

/* SNA RJE 'clear-to-send' and No 'clear-to-send' */
#define	RJE_CTS		991
#define	RJE_NOCTS	992

/* Printer end-of-bracket and end-of-session */
#define	ENDBRACKET	998
#define	ENDSESSION	999

/* Errors */

#define EBADPATH 	900	/* The communication gateway specified */
						/*  by path on the ds_open was not found */
#define ENOCTRLR	901	/* The communication gateway was not */
						/*  responding */
#define EDEVUNDEF	902	/* The device specified was not defined */
						/*  for the controller */
#define EDEVINUSE	903	/* The device specified was already in use */
#define EDEVTYPE	904	/* The device did not match DS_PRINTER */
#define EPROTTYPE	905	/* The device did not match DS_REJSNA */
						/*  or similiarly for DS_REJBSC */
#define ELUTYPE		906	/* The device did not match either */
						/*  DS_REJLU1 or DS_REJLU3 */
#define EACCESS		907	/* The client does not have permission to */
						/*  use the specified device */
#define ERESOURCES	908	/* The call failed due to lack of resources */
#define ENODAI		909	/* The dai specified was not active */
#define EBADBUFFER	910	/* The buffer is outside allocated addr space */
#define ENOPLU		911	/* PLU unavailable - DS_PLU(TRUE) ds_write */
#define ENOAPPL		911	/* For BSC: APPL unavailable */
#define ENOSSCP		912	/* SSCP unavailable - DS_PLU(FALSE) ds_write */
#define EBADCTL		913	/* The control value was not valid */
#define ERPCERR		914	/* The RPC call failed; rpc_err in ds_rpc_err */
#define EBADFLAGS	915	/* The flags value was not valid */
#define EIOCTRLR	916	/* Error other than EINTR or EPIPE on read or write */

extern int ds_open( unsigned char *, int, int, DS_DAI **, DS_STATUS * );
extern int ds_open_class( unsigned char *, int, int *, DS_DAI **, DS_STATUS *,
	unsigned char, int);
extern int ds_get_fd( DS_DAI *, int *);
extern int ds_close( DS_DAI *);
extern int ds_read( DS_DAI *, unsigned char *, int, int *, int *, DS_STATUS * );
extern int ds_write( DS_DAI *, unsigned char *, int, int, int *, DS_STATUS *);
extern int ds_write_control( DS_DAI *, enum ds_control );
