#ifndef lint
static  char sccsid[] = "@(#)dai_test.c 8.16 96/03/27 Copyr 1985-1993 Sun Micro";
#endif
/*
      Copyright 1993 Sun Microsystems, Inc. All Rights Reserved.
            Printed in the United States of America.
2550 Garcia Avenue, Mountain View, California, 94043-1100 U.S.A.

This product and related documentation is protected by 
copyright and distributed under licenses restricting its use, copying, 
distribution and decompilation.  No part of this product or related 
documentation may be reproduced in any form by any means without prior 
written authorization of Sun and its licensors, if any.

Portions of this product may be derived from the UNIX(R) and Berkeley 4.3 BSD 
systems, licensed from UNIX Systems Laboratories, Inc. and the University of 
California, respectively.  Third party font software in this product is
protected by copyright and licensed from Sun's Font Suppliers. 
  
RESTRICTED RIGHTS LEGEND:  Use, duplication, or disclosure by the government 
is subject to restrictions as set forth in subparagraph (c)(1)(ii) of the
Rights in Technical Data and Computer Software clause at DFARS 252.227-7013
and FAR 52.227-19.
 
Sun, Sun Microsystems, the Sun Logo, Solaris, SunOS, ONC, NFS, OpenWindows,
DeskSet, AnswerBook, SunLink, SunView, SunDiag, NeWS, OpenBoot, 
OpenFonts, SunInstall, SunNet, ToolTalk, X11/NeWS and XView are trademarks or 
registered trademarks of Sun Microsystems, Inc.  UNIX and OPEN LOOK are 
registered trademarks of UNIX System Laboratories, Inc. PostScript is a 
registered trademark of Adobe Systems, Inc.  All other product names 
mentioned herein are the trademarks of their respective owners.
 
All SPARC trademarks, including the SCD Compliant Logo, are trademarks or 
registered trademarks of SPARC International, Inc. SPARCstation, SPARCserver, 
SPARCengine, SPARCworks and SPARCompiler are licensed exclusively to Sun 
Microsystems, Inc.  Products bearing SPARC trademarks are based upon an 
architecture developed by Sun Microsystems, Inc. 

The OPEN LOOK(R) and Sun(TM) Graphical User Interfaces were developed by 
Sun Microsystems, Inc. for its users and licensees.  Sun acknowledges the 
pioneering efforts of Xerox in researching and developing the concept of 
visual or graphical user interfaces for the computer industry.  Sun holds 
a non-exclusive license from Xerox to the Xerox Graphical User Interface, 
which license also covers Sun's licensees who implement OPEN LOOK GUIs and 
otherwise comply with Sun's written license agreements.

The X Window System is a product of the Massachusetts Institute of 
Technology.

This product incorporates technology used under license from Fulcrum 
Technology.
*/

#include <stdio.h>
#include <memory.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/file.h>
#include <rpc/rpc.h>

#include "dai.h"

FILE *prfile = NULL;		/*  stderr replacement */
FILE *printfile = NULL;		/*  real printer output */

#define BUFSIZE 1024
u_char writebuffer[BUFSIZE];
u_char readbuffer[BUFSIZE+1];

DS_STATUS old_status;

extern int sys_nerr;
extern char *sys_errlist[];
extern int ds_nerr, ds_first_err;
extern char *ds_errlist[];
extern struct rpc_err ds_rpc_err;

static int errcode;

int partfound = 0;
int partlen = 0;
int bscmode = 0;
char *mode = "SNA";

#define	CLASS_PRINT	1	/* dsc or scs printer class */
#define CLASS_MOD2	2	/* terminal class, model 2 */
#define CLASS_MOD3	3	/* terminal class, model 3 */
#define CLASS_MOD4	4	/* terminal class, model 4 */
#define CLASS_MOD5	5	/* terminal class, model 5 */
#define CLASS_MAX	5	/* maximum number of classes */

u_char class = CLASS_MOD2; /* default class */
int continued_data = 0;
int last_ds_cmd = 0;
int last_ds_wcc = 0;
int ds_kybd_restore = 1;
#define KYBD_RESTORE 0x02

u_char ascii2ebcdic(); 
u_char ebcdic2ascii();
u_char hex2ebcdic();
char *getenv();

u_char queryid[] = {0x88,
                0x00, 0x0c,             /* Length */
                0x81, 0x95,             /* Query reply - DDM */
                0x00, 0x00,             /* Flags */
                0x08, 0x00,             /* LIMIN */
                0x08, 0x00,             /* LIMOUT */
                0x01, 0x01};            /* Subsets supported */		

static char * classes[] =
{
	"printer",	/* class = 1	printer class,  model 1 */
	"model02",	/* class = 2	terminal class, model 2 */
	"model03",	/* class = 3	terminal class, model 3 */
	"model04",	/* class = 4	terminal class, model 4 */
	"model05",	/* class = 5	terminal class, model 5 */
};
main(int argc, char *argv[])
{
	DS_DAI *dai;
	DS_STATUS status;
	int flags;
	int rbytes;
	int fd_for_select;
	int device = -1;		/* allow any (next available device) */
	int props = (DS_RM_SNA | DS_PRINTER | DS_SNAPRT | DS_RM_BSC | DS_DA_CHL);
	char *prfile_name = "prfile";
	char *envclass = "class";
	char *print_class = "printer";
	char *pf, *cl;
	int bufsize = 24*80;
	int i;
	int printfd;
	int last_read_len = 0;

	/*
	 *  Obtain 'stderr' file replacement from
	 *  the environment variable named : "prfile"
	 *  If none exists default to 'stderr'.
	 */
	pf = getenv(prfile_name);
	if (pf) prfile = fopen(pf,"w");
	if ( ! prfile) prfile = stderr;

	/*
	 *  Obtain class from "class" environment
	 *  variable.  If none, *  default to 
	 *  class = CLASS_MOD2.
	 */
	cl = getenv(envclass);
	if(cl) {
		for (i=0; i<CLASS_MAX; i++) {
			if(strncmp(classes[i], cl, strlen(classes[i]) == 0)) {
				class = i+1;
			}
		}
		if(i == CLASS_MAX) {
			class = CLASS_MOD2;
			props &= ~DS_PRINTER;
		}
	} else {
		class = CLASS_MOD2;
		props &= ~DS_PRINTER;
	}
	if(cl && (strncmp(print_class, cl, strlen(print_class)) == 0))
	{
		class = CLASS_PRINT;
		props |= DS_PRINTER;
	}

	if (class != CLASS_PRINT) {
		if (argc < 2)
		{
		(void)fprintf(prfile, "Sorry, usage is daitest <instanceName>\n");
		fflush(prfile);
		exit(-1);
		}
	} else {
		if (argc < 3)
		{
		(void)fprintf(prfile, "Sorry, usage is daitest <instanceName> <printerfileName>\n");
		fflush(prfile);
		exit(-1);
		}
		if (argv[2]) 
			printfile = fopen(argv[2], "w");
		if ( ! printfile ) {
			(void)fprintf(prfile, "Sorry, supplied <printfileName> cannot be opened\n");
			fflush(prfile);
			exit(-1);
		}
		fclose(printfile);	/* this justs creates the file */
		printfd = open(argv[2], O_WRONLY);
		if( printfd < 0) {
			(void)fprintf(prfile, "Sorry, supplied <printfileName> cannot be opened\n");
			fflush(prfile);
			exit(-1);
		}
	}

	(void)fprintf(prfile, "Calling ds_open_class...\n");
	fflush(prfile);
	if ((errcode = ds_open_class((u_char *)argv[1], device, &props, &dai, &status,
            class, bufsize)) != 0)
	{
		(void)fprintf(prfile, "ds_open_class failed, ");
		fflush(prfile);
		(void)print_errcode();
		exit(-1);
	}

	if (status.ds_termno == DS_UNKNOWN)
		(void)fprintf(prfile, "terminal number is unknown\n");
	else
		(void)fprintf(prfile, "terminal number is %03x\n", status.ds_termno);

	printstatus(&status);
	fflush(prfile);
	switch(props & ~DS_PRINTER) {
		case DS_RM_BSC:
			bscmode = 1;
			mode = "BSC";
			break;
		case DS_DA_CHL:
			bscmode = 2;
			mode = "LCL";
			break;
		default:
			bscmode = 0;
			mode = "SNA";
			break;
	}
	
	(void)fprintf(prfile, "Calling ds_get_fd...\n");
	if ((errcode = ds_get_fd(dai, &fd_for_select)) != 0)
	{
		(void)fprintf(prfile, "ds_get_fd failed, ");
		fflush(prfile);
		(void)print_errcode();
		close_on_error(dai);
	}
	(void)fprintf(prfile, "ds_get_fd set fd_for_select = %d\n", fd_for_select);
	fflush(prfile);
	
if (bscmode) { /* BSC Mode */
	if (class != CLASS_PRINT) {
		wait_for_text(dai, "PRESS ENTER OR CLEAR KEY TO BEGIN SESSION", &status);
		write_DSC(dai, 23, 1, "", ENTER, &status);
		wait_for_text(dai, "Enter one of the following commands:", &status);
		write_DSC(dai, 23, 1, "logon sun1 sun", ENTER, &status);
		wait_for_text(dai, "R; T=", &status);
		write_DSC(dai, 23, 1, "set msg off", ENTER, &status);
		wait_for_text(dai, "R; T=", &status);
		write_DSC(dai, 23, 1, "logoff", ENTER, &status);
		wait_for_text(dai, "PRESS ENTER OR CLEAR KEY TO CONTINUE", &status);
		write_DSC(dai, 23, 1, "", ENTER, &status);
		wait_for_text(dai, "PRESS ENTER OR CLEAR KEY TO BEGIN SESSION", &status);
	} else { /* BSC printer data */
#ifdef DEBUG
		(void)fprintf(prfile, "BSC Mode; capture printer data\n");
		fflush(prfile);
#endif
		while(1) {
			do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, &status);

			(void)fprintf(prfile,"Read %d bytes of printer data\n", rbytes);
			(void)fprintf(prfile,"Read flags = 0x%x.\n", flags);
			fflush(prfile);

			i = write(printfd, readbuffer, rbytes);
#ifdef DEBUG
			fprintf(prfile,"wrote bytes=%d to printfd\n", i);
			fflush(prfile);
#endif

			if (!(flags & DS_MORE) && (last_read_len != 0)) {
				(void)fprintf(prfile, "Calling ds_write_control...\n");
				fflush(prfile);
				if ((errcode = ds_write_control(dai, ds_nby)) != 0)
				{
					(void)fprintf(prfile, "ds_write_control failed, ");
					fflush(prfile);
					(void)print_errcode();
					close_on_error(dai);
				}
			}
			last_read_len = rbytes;
		}
	}
} else { /* SNA Mode */
	if (class != CLASS_PRINT) {
		(void)fprintf(prfile, "Waiting for state == DS_SSCP\n");
		while(status.ds_state != ds_sscp)
			do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, &status);
		wait_for_text(dai, "ENTER SYSTEM ID", &status);
		write_SSCP(dai, "tsoq", &status);
		wait_for_text(dai, "ENTER LOGON ID", &status);
		write_DSC(dai, 1, 37, "california", ENTER, &status);
		wait_for_text(dai, "ENTER PASSWORD", &status);
		write_DSC(dai, 1, 37, "mtview", ENTER, &status);
		wait_for_text(dai, "LOGON IN PROGRESS", &status);
		wait_for_text(dai, "***", &status);
		write_DSC(dai, 23, 22, "", ENTER, &status);
		wait_for_text(dai, "READY", &status);
		write_DSC(dai, 1, 37, "ispf", ENTER, &status);
		wait_for_text(dai, "OPTION MENU", &status);
		write_DSC(dai, 2, 15, "end", ENTER, &status);
		wait_for_text(dai, "READY", &status);
		write_DSC(dai, 1, 80, "12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890", ENTER, &status);
		wait_for_text(dai, "READY", &status);
		write_DSC(dai, 1, 80, "logoff", ENTER, &status);
		(void)fprintf(prfile, "Waiting for state != DS_APPL\n");
		while(status.ds_state == ds_appl)
			do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, &status);
	} else {	/* SNA printer data */
#ifdef DEBUG
		(void)fprintf(prfile, "SNA Mode; capture printer data\n");
		fflush(prfile);
#endif
		while(1) {
			do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, &status);
#ifdef DEBUG
			(void)fprintf(prfile,"Read %d bytes of printer data\n",
				rbytes);
			fflush(prfile);
#endif
			i = write(printfd, readbuffer, rbytes);
#ifdef DEBUG
			fprintf(prfile,"'wrote' bytes=%d to printfd\n", i);
			fflush(prfile);
#endif
		}
	}
}		/* if (bscmode) else (sna) */

	(void)fprintf(prfile, "Calling ds_close...\n");
	fflush(prfile);
	if ((errcode = ds_close(dai)) != 0)
	{
		(void)fprintf(prfile, "ds_close failed, ");
		fflush(prfile);
		(void)print_errcode();
		exit(-1);
	}
	return(0);
}

print_errcode()
{
	if (errcode < sys_nerr)
		(void)fprintf(prfile, "errcode = %d, %s\n", errcode, 
			sys_errlist[errcode]);
	else if ((errcode >= ds_first_err) && 
			((errcode - ds_first_err) < ds_nerr))
		{
			(void)fprintf(prfile, "errcode = %d, %s\n", errcode,
				ds_errlist[errcode - ds_first_err]);
			if (errcode == ERPCERR)
				(void)fprintf(prfile, "rpc error code = %d\n",
					(int)ds_rpc_err.re_status);
		}
	else (void)fprintf(prfile, "errcode = %d, unknown error\n", errcode);
	fflush(prfile);
}

wait_for_text(DS_DAI *dai, u_char *c, DS_STATUS *status)
{
	int flags;
	int rbytes;
	int found = 0;
	
	(void)fprintf(prfile, "Waiting for %s...\n", c);
	fflush(prfile);
	partfound = partlen = 0;
	for (;;)
	{
		do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, status);
		if (! found)
			found = look_for(rbytes, c);
		if (found && (! (flags & DS_MORE)))
			break;
		if (bscmode)
			if (! ((flags & DS_MORE) || (flags  & DS_NEWCMD)))
				partfound = partlen = 0;
		else			
			if (! (flags & DS_MORE))
				partfound = partlen = 0;
	}
}

look_for(int rbytes, u_char *c)
{
	int i;
	u_char *cp;

	for (i=0; i < rbytes; i++)
	{
		readbuffer[i] = ebcdic2ascii(readbuffer[i]);
		if (readbuffer[i] == '\0')
			readbuffer[i] = 0xff;
	}
	readbuffer[rbytes] = '\0';
	cp = readbuffer;
	
	if (partfound)
	{
		if ((int) strlen((char *)cp) < (int) (strlen((char *)c)-partlen))
		{
			if (strncmp((char *)cp, (char *)&c[partlen], strlen((char *)cp)) == 0)
			{
				partlen = partlen + strlen((char *)cp);
				return(0);
			}
		}
		else
		{
			if (strncmp((char *)cp, (char *)&c[partlen], strlen((char *)c)-partlen) == 0)
				return(1);
		}
		partfound = partlen = 0;
	}
	
	while ((cp = (u_char *)strchr((char *)cp, c[0])) != (u_char *) 0)
	{
		if ((int) strlen((char *)cp) < (int) strlen((char *)c))
		{
			if (strncmp((char *)cp, (char *)c, strlen((char *)cp)) == 0)
			{
				partfound = 1;
				partlen = strlen((char *)cp);
				return(0);
			}
		}
		else
		{
			if (strncmp((char *)cp, (char *)c, strlen((char *)c)) == 0)
				return(1);
		}
		cp++;
	}
	return(0);
}

wait_for_unlocked(DS_DAI *dai, DS_STATUS *status)
{
	int flags, rbytes;

	if ((status->ds_kybdlk != 0) || (! ds_kybd_restore))
	{
		(void)fprintf(prfile, "Waiting for keyboard unlocked: ");
		if (status->ds_kybdlk != 0)
			(void)fprintf(prfile, "%s", mode);
		if ((status->ds_kybdlk != 0) && (! ds_kybd_restore))
			(void)fprintf(prfile, " and ");
		if (! ds_kybd_restore)
			(void)fprintf(prfile, "WCC");
		(void)fprintf(prfile, "\n");
		fflush(prfile);
		while ((status->ds_kybdlk != 0) || (! ds_kybd_restore))
			do_read(dai, readbuffer, BUFSIZE, &flags, &rbytes, status);
		(void)fprintf(prfile, "Keyboard unlocked\n");
		fflush(prfile);
	}
}

write_SSCP(DS_DAI *dai, u_char *c, DS_STATUS *status)
{
	int count = 0;

	wait_for_unlocked(dai, status);
	(void)fprintf(prfile, "Calling ds_write_control...\n");
	fflush(prfile);
	if ((errcode = ds_write_control(dai, ds_key)) != 0)
	{
		(void)fprintf(prfile, "ds_write_control failed, ");
		fflush(prfile);
		(void)print_errcode();
		close_on_error(dai);
	}
	while (*c)
		writebuffer[count++] = ascii2ebcdic(*c++);
	do_write(dai, writebuffer, count, 0, status);
}

	/* row is 1-24, column is 1-80 */

write_DSC(DS_DAI *dai, int row, int col, u_char *c, int aid, DS_STATUS *status)
{
	int count = 0;
	int flags = (bscmode) ? 0 : DS_PLU;
	int firstChar, secondChar;
	
	wait_for_unlocked(dai, status);
	(void)fprintf(prfile, "Calling ds_write_control...\n");
	fflush(prfile);
	if ((errcode = ds_write_control(dai, ds_key)) != 0)
	{
		(void)fprintf(prfile, "ds_write_control failed, ");
		fflush(prfile);
		(void)print_errcode();
		close_on_error(dai);
	}
	xytobufpos(row, col+strlen((char *)c), &firstChar, &secondChar);
	writebuffer[count++] = aid;
	writebuffer[count++] = hex2ebcdic(firstChar);
	writebuffer[count++] = hex2ebcdic(secondChar);
	xytobufpos(row, col, &firstChar, &secondChar);
	writebuffer[count++] = 0x11;
	writebuffer[count++] = hex2ebcdic(firstChar);
	writebuffer[count++] = hex2ebcdic(secondChar);
	if (strlen((char *)c) != 0)
	{
		while (*c)
			writebuffer[count++] = ascii2ebcdic(*c++);
	}
	do_write(dai, writebuffer, count, flags, status);
}

/* 
	For the time being, we don't implement the general case.
	We just check for the WSF Query ID when do_read is called
	and send a canned "queryid" reply (of DDM -- file transfer).

write_SF(DS_DAI *dai, u_char *buffer, int len, DS_STATUS *status)
{
	int count = 0;
	int flags = (bscmode) ? 0 : DS_PLU;
	
	wait_for_unlocked(dai, status);
	(void)fprintf(prfile, "Calling ds_write_control...\n");
	fflush(prfile);
	if ((errcode = ds_write_control(dai, ds_key)) != 0)
	{
		(void)fprintf(prfile, "ds_write_control failed, ");
		fflush(prfile);
		(void)print_errcode();
		close_on_error(dai);
	}
	writebuffer[count++] = 0x88;
	memcpy((u_char *)&writebuffer[count], (u_char *)buffer, (int)len);
	count += len;
	do_write(dai, writebuffer, count, flags, status);
}

*/

do_write(DS_DAI *dai, u_char *buffer, int nbytes, int flags, DS_STATUS *status)
{
	int wbytes = 0;

	while (wbytes == 0) 
	{
		(void)fprintf(prfile, "Calling ds_write...\n");
		fflush(prfile);
		if ((errcode=ds_write(dai,buffer,nbytes,flags,&wbytes,status)) != 0)
		{
			(void)fprintf(prfile, "ds_write failed, ");
		fflush(prfile);
			(void)print_errcode();
			close_on_error(dai);
		}
		printstatus(status);
		wait_for_unlocked(dai, status);
	}
	if (wbytes != nbytes)
	{
		(void)fprintf(prfile, 
			"ds_write failed, %d bytes passed, %d bytes written\n", 
			nbytes, wbytes);
		fflush(prfile);
		printstatus(status);
		close_on_error(dai);
	}
	printstatus(status);
}

do_read(DS_DAI *dai, u_char *buffer, int nbytes, int *flags, 
		int *rbytes, DS_STATUS *status)
{
reread:
	(void)fprintf(prfile, "do_read: Calling ds_read...\n");
	fflush(prfile);
	if ((errcode = ds_read(dai,buffer,nbytes,flags,rbytes,status)) != 0)
	{
		if ( (errcode != ENDBRACKET) && (errcode != ENDSESSION) ) {
			(void)fprintf(prfile, "do_read: ds_read failed\n");
			fflush(prfile);
			(void)print_errcode();
			close_on_error(dai);
		}
	}
	(void)fprintf(prfile, "do_read: returned from ds_read...\n");
	fflush(prfile);
	/* Check for query id */
	if ((*rbytes == 6) &&
	    (buffer[0] == 0xf3) &&
	    (buffer[3] == 0x01) && 
	    (buffer[4] == 0xff) &&
	    (buffer[5] == 0x02)) {
		(void)fprintf(prfile, "do_read: ds_read read query id\n");
		fflush(prfile);
		wait_for_unlocked(dai, status);
		do_write(dai, queryid, sizeof(queryid), (bscmode) ? 0 : DS_PLU, status);
		goto reread;
	}

	if (((bscmode) || (*flags & DS_PLU)) && (! continued_data))
	{
		/* need to get at least the first 2 bytes of the ds */
		if (*rbytes > 1)
		{
			last_ds_cmd = buffer[0];
			last_ds_wcc = buffer[1];
			ds_kybd_restore = (last_ds_wcc & KYBD_RESTORE);
		}
		else if (*rbytes == 1) (void)fprintf(prfile, "Only one byte read.\n");
		/* Zero bytes of data read would be for status change. */
	}
	fflush(prfile);
	continued_data = (*flags & DS_MORE);
	printstatus(status);
}

close_on_error(DS_DAI *dai)
{
	(void)fprintf(prfile, "Calling ds_close...\n");
	fflush(prfile);
	if ((errcode = ds_close(dai)) != 0)
	{
		(void)fprintf(prfile, "ds_close failed, ");
		fflush(prfile);
		(void)print_errcode();
	}
	exit(-1);
}


printstatus(DS_STATUS *status)
{
	char *printstate(), *printtype(), *printkybdlk();

	if (class != CLASS_PRINT) {
		(void)fprintf(prfile, 
		  "Status: %s : %s : %s : %d: %d\n", printstate(status),
			printtype(status), printkybdlk(status), 
				status->ds_err400, status->ds_err500);
	} else {
		(void)fprintf(prfile, "Status: %s : %s : %d: %d\n",
			printstate(status), printtype(status), 
				status->ds_err400, status->ds_err500);
	}
	if ((status->ds_size[0] != old_status.ds_size[0]) || 
		(status->ds_size[1] != old_status.ds_size[1]) ||
		(status->ds_size[2] != old_status.ds_size[2]) ||
		(status->ds_size[3] != old_status.ds_size[3]) ||
		(status->ds_size[4] != old_status.ds_size[4]))
		(void)fprintf(prfile, "Status ds_size: %d : %d : %d : %d: %d\n",
			status->ds_size[0], status->ds_size[1], status->ds_size[2], 
			status->ds_size[3], status->ds_size[4]);
	fflush(prfile);
	old_status = *status;
}

char *
printstate(DS_STATUS *status)
{
	if (status->ds_state == old_status.ds_state)
	{
		switch(status->ds_state)
		{
		case ds_inact:		return("ds_inact  ");
		case ds_appl:		return("ds_appl   ");
		case ds_sscp:		return("ds_sscp   ");
		case ds_unown:		return("ds_unown  ");
		case ds_unavail:	return("ds_unavail");
		default:		return("???state??");
		}
	}
	else
	{
		switch(status->ds_state)
		{
		case ds_inact:		return("DS_INACT  ");
		case ds_appl:		return("DS_APPL   ");
		case ds_sscp:		return("DS_SSCP   ");
		case ds_unown:		return("DS_UNOWN  ");
		case ds_unavail:	return("DS_UNAVAIL");
		default:		return("???STATE??");
		}
	}
}

char *
printtype(DS_STATUS *status)
{
	if (status->ds_type == old_status.ds_type)
	{
		switch(status->ds_type)
		{
		case ds_ptr_scs:	return("ds_ptr_scs");
		case ds_ptr_dsc:	return("ds_ptr_dsc");
		case ds_bscptr:		return("ds_bscptr");
		case ds_display:	return("ds_display");
		default:	return("??type??");
		}
	}
	else
	{
		switch(status->ds_type)
		{
		case ds_ptr_scs:	return("DS_PTR_SCS");
		case ds_ptr_dsc:	return("DS_PTR_DSC");
		case ds_bscptr:		return("DS_BSCPTR");
		case ds_display:	return("DS_DISPLAY");
		default:	return("??TYPE??");
		}
	}
}

char *
printkybdlk(DS_STATUS *status)
{
	if (status->ds_kybdlk == old_status.ds_kybdlk)
	{
		switch(status->ds_kybdlk)
		{
		case 0:		return("keyboard unlocked");
		default:	return("keyboard locked  ");
		}
	}
	else
	{
		switch(status->ds_kybdlk)
		{
		case 0:		return("KEYBOARD UNLOCKED");
		default:	return("KEYBOARD LOCKED  ");
		}

	}
}

/* This function converts a row,col position to a buffer position. */
/* Then returns the two offsets to be used in the hex2ebcdic table below. */

xytobufpos(int row, int col, int *firstChar, int *secondChar)
{
	int bufpos = ( ( (row-1) * 80 ) + (col-1) );
	
	*firstChar = (bufpos >> 6);
	*secondChar = (bufpos & 0x03f);
}

u_char
hex2ebcdic(register u_int chr)
{
    static u_char hexTable[] = {		/* HEX to EBCDIC table */
/* 00 */    0x40, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 
/* 08 */    0xc8, 0xc9, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 
/* 10 */    0x50, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 
/* 18 */    0xd8, 0xd9, 0x5a, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f, 
/* 20 */    0x60, 0x61, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 
/* 28 */    0xe8, 0xe9, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 
/* 30 */    0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 
/* 38 */    0xf8, 0xf9, 0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f };
    chr &= 0x3f;
    return(hexTable[chr]);
}	

u_char
ascii2ebcdic(register u_int chr)
{
    static u_char ebcdicTable[] = {	/* ASCII to EBCDIC table */
/* 00 000 */    0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f, 
/* 08 010 */    0x16, 0x05, 0x25, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 
/* 10 020 */    0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26, 
/* 18 030 */    0x18, 0x19, 0x3f, 0x27, 0x1c, 0x1d, 0x1e, 0x1f, 
/* 20 040 */    0x40, 0x5a, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d, 
/* 28 050 */    0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61, 
/* 30 060 */    0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 
/* 38 070 */    0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f, 
/* 40 100 */    0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 
/* 48 110 */    0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 
/* 50 120 */    0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 
/* 58 130 */    0xe7, 0xe8, 0xe9, 0xad, 0xe0, 0xbd, 0x5f, 0x6d, 
/* 60 140 */    0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 
/* 68 150 */    0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 
/* 70 160 */    0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 
/* 78 170 */    0xa7, 0xa8, 0xa9, 0xc0, 0x4f, 0xd0, 0xa1, 0x07 };
    chr &= 0x7f;
    return(ebcdicTable[chr]);
}	

u_char
ebcdic2ascii(register u_int chr)
{
    u_int ascii_chr;
    static u_char asciiTable[] = {	/* EBCDIC to ASCII table */
/* 00 */    0x00, 0x01, 0x02, 0x03, 0x9c, 0x09, 0x86, 0x7f,
/* 08 */    0x97, 0x8d, 0x8e, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
/* 10 */    0x10, 0x11, 0x12, 0x13, 0x9d, 0x0a, 0x08, 0x87,
/* 18 */    0x18, 0x19, 0x92, 0x8f, 0x1c, 0x1d, 0x1e, 0x1f,
/* 20 */    0x80, 0x81, 0x82, 0x83, 0x84, 0x0a, 0x17, 0x1b,
/* 28 */    0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x05, 0x06, 0x07,
/* 30 */    0x90, 0x91, 0x16, 0x93, 0x94, 0x95, 0x96, 0x04,
/* 38 */    0x98, 0x99, 0x9a, 0x9b, 0x14, 0x15, 0x9e, 0x1a,
/* 40 */    0x20, 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
/* 48 */    0xa7, 0xa8, 0xd5, 0x2e, 0x3c, 0x28, 0x2b, 0x7c,
/* 50 */    0x26, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
/* 58 */    0xb0, 0xb1, 0x21, 0x24, 0x2a, 0x29, 0x3b, 0x5e,
/* 60 */    0x2d, 0x2f, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7,
/* 68 */    0xb8, 0xb9, 0xcb, 0x2c, 0x25, 0x5f, 0x3e, 0x3f,
/* 70 */    0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf, 0xc0, 0xc1,
/* 78 */    0xc2, 0x60, 0x3a, 0x23, 0x40, 0x27, 0x3d, 0x22,
/* 80 */    0xc3, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
/* 88 */    0x68, 0x69, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
/* 90 */    0xca, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70,
/* 98 */    0x71, 0x72, 0x7e, 0x7e, 0xcd, 0xce, 0xcf, 0xd0,
/* a0 */    0xd1, 0x7e, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
/* a8 */    0x79, 0x7a, 0xd2, 0xd3, 0xd4, 0x5b, 0xd6, 0xd7,
/* b0 */    0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
/* b8 */    0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0x5d, 0xe6, 0xe7,
/* c0 */    0x7b, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
/* c8 */    0x48, 0x49, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed,
/* d0 */    0x7d, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 0x50,
/* d8 */    0x51, 0x52, 0xee, 0xef, 0xf0, 0xf1, 0xf2, 0xf3,
/* e0 */    0x5c, 0x9f, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
/* e8 */    0x59, 0x5a, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
/* f0 */    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
/* f8 */    0x38, 0x39, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff };
    chr &= 0xff;
    ascii_chr = asciiTable[chr];
    if (ascii_chr >= 0x80) ascii_chr = 0x3f; /* use "?" if value is non-ASCII */
    return(ascii_chr);
}	
